
public class CEmployee2 implements Comparable<CEmployee2> {
	int id;
	double salary;
	
	CEmployee2(int id) {
		this.id = id;
	} 
	
	void setSalary(double salary) {
		this.salary = salary;
	}
	
//	@Override
//	public int compareTo(CEmployee2 other) {
//		/*
//		 * If this.salary > other.salary, then 
//		 * Double.compare(this.salary, other.salary) returns positive,
//		 * Since we want to put employees with larger salary at the front,
//		 * we need to invert the sign! 
//		 */
//		int salaryDiff = Double.compare(this.salary, other.salary);
//		int idDiff = this.id - other.id;
//		if(salaryDiff != 0) {
//			return -salaryDiff;
//		}
//		else {
//			return idDiff;
//		}
//	}
	
	/* Alternatively, just use more if-then-else to make the logic
	 * more explicit.
	 */
	@Override
	public int compareTo(CEmployee2 other) { 
		if(this.salary > other.salary) {
			return -1;
		}
		else if (this.salary < other.salary) {
			return 1;
		}
		else { /* equal salaries */
			return this.id - other.id;
		}
	}
}
